#include "LibAttr.h"

LibAttr::~LibAttr()
{
  LibVal* val;

  if (d_type == LIBERTY__SIMPLE) {
    if (!d_u.value) return;
    delete d_u.value;
  } else {
    if (!d_u.vlist) return;

    LibValIter iter = valueIter();
    while (iter) {
      val = *iter;
      d_u.vlist->remove(iter++);
      delete val;
    }
    delete d_u.vlist;
  }
}

void
LibAttr::dump(FILE *f, const char* indent)
{
  fprintf(f, "%s%s", indent, (str_t)d_name);
  switch (d_type) {
  case LIBERTY__SIMPLE:
    d_u.value->dump(f, " : ", ";\n");
    break;
  case LIBERTY__COMPLEX:
    LibValIter viter = valueIter();
    LibVal *v;
    int first = 1;
    fprintf(f, "(");
    while ((v = viter++)) {
      if (!first) fprintf (f, ",");
      v->dump(f, "", "");
      first = 0;
    }
    fprintf(f, ");\n");
    break;
  }
}

